//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Aqua
#property indicator_color2  Yellow

//
//
//
//
//

extern double         StochPeriod        = 9;
extern ENUM_MA_METHOD StochMaMethod      = MODE_EMA;
extern ENUM_STO_PRICE StochPrice         = PRICE_CLOSE;
extern double         stoch_max          = 53;
extern double         stoch_min          = 47;
extern double         atr_period         = 7;
extern bool           alertsOn           = true;
extern bool           alertsOnCurrent    = true;
extern bool           alertsMessage      = true;
extern bool           alertsSound        = true;
extern bool           alertsEmail        = false;
extern bool           alertsNotify       = false;

extern double         arrowsDisplacement = 0.5;
extern int            DotWidth           = 2;


//
//
//
//
//

double arrUp[];
double arrDn[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,arrUp);  SetIndexStyle(0,DRAW_ARROW,0,DotWidth); SetIndexArrow(0,108);
      SetIndexBuffer(1,arrDn);  SetIndexStyle(1,DRAW_ARROW,0,DotWidth); SetIndexArrow(1,108);
      SetIndexBuffer(2,trend); 
     
   IndicatorShortName("BrainTrend Signal");   
return(0);
}  
int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 

   //
   //
   //
   //
   //

     for(i=limit; i>=0; i--)
     {
        double atr    = iATR(NULL,0,atr_period,i)/2.3;
        double stoch  = iStochastic(NULL,0,StochPeriod,StochPeriod,1,StochMaMethod,StochPrice,1,i);
        double cldiff =  MathAbs(Close[i] - Close[i+2]);
        double gap    = iATR(NULL,0,20,i); 
        
           trend[i] = trend[i+1];
           if (cldiff > atr && stoch < stoch_min) trend[i] =-1;
           if (cldiff > atr && stoch > stoch_max) trend[i] = 1;
        
           //
           //
           //
           //
           //
    
           arrUp[i] = EMPTY_VALUE;
           arrDn[i] = EMPTY_VALUE;
           if (trend[i]!= trend[i+1])
           if (trend[i] == 1)
                 arrUp[i] = Low[i]  - arrowsDisplacement * gap;
           else  arrDn[i] = High[i] + arrowsDisplacement * gap;
     }      
     
   //
   //
   //
   //
   //
         
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("up");
      else  doAlert("down");       
   }
return(0);
}
      
//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Brain Trend Signal ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Brain Trend Signal "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

